田草博客
日志搜索


 标题   内容 评论


网友交流QQ群:11740834 需注明申请加入原因

微信 公众号:ByCAD

邮箱:tiancao1001x126.com
ByCAD,微信公众号
首页 | 普通 | 电脑 | AutoCAD | VB/VB.NET | FLash | 结构 | 建筑 | 电影 | BIM | 规范 | 软件
-电信用户-|-网通用户-
-博客论坛-|-软件下载-
-网站导航-|-规范下载-
-BelovedFLash欣赏-

用户登陆
用户:
密码:
 

站点日历
73 2018 - 12 48
      1
2345678
9101112131415
16171819202122
23242526272829
3031


站点统计

最新评论



隐藏日志,无权浏览 VB.NET 打印当前窗体
未知 创建多行文字属性快   [ 日期:2018-12-08 ]   [ 来自:本站原创 ]  HTML


https://adndevblog.typepad.com/autocad/2013/06/creat ... i-line-attribute-definition.html

程序代码:

    Friend Shared Sub CreateMyBlock()
        Dim db As Database = Application.DocumentManager.MdiActiveDocument.Database
        Using tr As Transaction = db.TransactionManager.StartTransaction()
            Dim bt As BlockTable = TryCast(tr.GetObject(db.BlockTableId, OpenMode.ForRead), BlockTable)
            If bt.Has("MyBlock") = False Then
        bt.UpgradeOpen()
        Dim btr As New BlockTableRecord()
                btr.Name = "MyBlock"
                btr.Origin = Point3d.Origin
                bt.Add(btr)
                tr.AddNewlyCreatedDBObject(btr, True)
                ' Attribute Definition
                Dim attdef As New AttributeDefinition(Point3d.Origin, "MilliSeconds\PSeconds\PMinutes", "Time", "Time ?", db.Textstyle)
                attdef.IsMTextAttributeDefinition = True
                btr.AppendEntity(attdef)
                tr.AddNewlyCreatedDBObject(attdef, True)
            End If
            tr.Commit()
        End Using
    End Sub
    Friend Shared Sub CreateMyBlockRef()
        Dim doc As Document = Application.DocumentManager.MdiActiveDocument
        Dim db As Database = doc.Database
        Dim ed As Editor = doc.Editor
        Dim ppo As New PromptPointOptions(vbLf & "Specify insertion point :")
        Dim ppr As PromptPointResult = ed.GetPoint(ppo)
        If ppr.Status <> PromptStatus.OK Then
            Return
        End If
        Dim insertionPoint As Point3d = ppr.Value
        Using tr As Transaction = db.TransactionManager.StartTransaction()
            Dim bt As BlockTable = TryCast(db.BlockTableId.GetObject(OpenMode.ForRead), BlockTable)
            Dim blockDef As BlockTableRecord = TryCast(bt("MyBlock").GetObject(OpenMode.ForRead), BlockTableRecord)
            Dim ms As BlockTableRecord = TryCast(bt(BlockTableRecord.ModelSpace).GetObject(OpenMode.ForWrite), BlockTableRecord)
            Dim blockRef As New BlockReference(insertionPoint, blockDef.ObjectId)
            ms.AppendEntity(blockRef)
            tr.AddNewlyCreatedDBObject(blockRef, True)
            For Each id As ObjectId In blockDef
                Dim obj As DBObject = id.GetObject(OpenMode.ForRead)
                Dim attDef As AttributeDefinition = TryCast(obj, AttributeDefinition)
                If (attDef IsNot Nothing) AndAlso (Not attDef.Constant) Then
                    Dim attRef As New AttributeReference()
                    attRef.SetAttributeFromBlock(attDef, blockRef.BlockTransform)
                    attRef.TextString = [String].Format("MilliSeconds : {0}\PSeconds : {1}\PMinutes : {2}", DateTime.Now.Millisecond.ToString(), DateTime.Now.Second.ToString(), DateTime.Now.Minute.ToString())
                    blockRef.AttributeCollection.AppendAttribute(attRef)
                    tr.AddNewlyCreatedDBObject(attRef, True)
                End If
            Next
            tr.Commit()
        End Using
    End Sub
    <CommandMethod("Test")> _
    Public Shared Sub TestMethod()
        CreateMyBlock()
        CreateMyBlockRef()
    End Sub






暂时没有评论
发表评论 - 不要忘了输入验证码哦!
作者: 用户:  密码:   注册? 验证:  防止恶意留言请输入问题答案:2*5=?  
评论:

禁止表情
禁止UBB
禁止图片
识别链接
识别关键字

字体样式 文字大小 文字颜色
插入粗体文本 插入斜体文本 插入下划线
左对齐 居中对齐 右对齐
插入超级链接 插入邮件地址 插入图像
插入 Flash 插入代码 插入引用
插入列表 插入音频文件 插入视频文件
插入缩进符合
点击下载按钮 下标 上标
水平线 简介分割标记
表  情
 
Tiancao Blog All Rights Reserved 田草博客 版权所有
Copyright ©